# zero out some useless deps.
# (tv) we'd better had a link in minicom & package Encode::HanConvert:
%define _requires_exceptions HanConvert\\|runscript

# don't spend time with this either
%define _enable_debug_packages	%{nil}
%define debug_package		%{nil}

Summary:	An SSL web-based administration interface for Unix systems
Name:		webmin
Version:	1.690
Release:	%mkrel 1
License:	BSD
Group:		System/Configuration
URL:		http://www.webmin.com/webmin/
Source0:	http://heanet.dl.sourceforge.net/project/webadmin/%{name}/%{version}/%{name}-%{version}.tar.gz
Source2:	other.modules.tar.bz2
# some images were missing
Source33:	advanced.png
Source34:	descs.png
Source4:	webmin-postinstallscript.sh
Source5:	webmin
Source6:	webmin.initscript
Source9:	http://www.openit.it/index.php/openit_en/content/download/2474/10171/file/openvpn-2.0.wbm.gz
Source10:	webmin.pam
Source11:	webmin-16.png
Source12:	webmin-32.png
Source13:	webmin-48.png
# uses include instead of pam_stack
Source14:	webmin.pam-new
Source15:	webmin.logrotate
# (gc) have the updates; this needs to change for each version and/or release, see
#      http://www.webmin.com/webmin/updates.html
Patch1:		webmin-1.610-remove-atboot-problem
Patch5:		webmin-fix-newmods.patch
Patch7:		webmin-0.85-never-fail-detect-os.patch
Patch8:		webmin-0.85-enable-changed-theme-at-installation.patch

Patch19:	webmin-0.92-add-default-configs-logviewer-fp2k.patch
Patch21:	webmin-0.950-add-netsaint-mandrake-config.patch
Patch23:	webmin-1.020-ssl-location.patch
Patch29:	webmin-1.100-let-localauth-config.patch
Patch32:	webmin-1.310-usermin-fix-installing-missing-package.diff
Patch35:	webmin-1.220-usermin-fix-index.patch
Patch37:	webmin-temp-permission-fix.diff
Patch38:	webmin-ssldir-cosmetic.diff
Patch39:	webmin-fix-bandwith.diff
Patch44:	webmin-openvpn-config.patch
Patch45:	webmin-1.670-disable-update-notifications.patch
Requires(post): systemd >= %{systemd_required_version}
Requires(pre):  rpm-helper
Requires:	perl
Requires:	perl-CGI
Requires:	perl(Authen::Libwrap)
Requires:	perl(IO::Tty)
Requires:	lsof
Requires(pre): sed chkconfig findutils coreutils initscripts grep perl-Net_SSLeay perl-Authen-PAM
Provides:	%{name}-%{version}
BuildArch:	noarch

%description
A web-based administration interface for Unix systems. Using Webmin you can
configure DNS, Samba, NFS, local/remote filesystems, Apache, Sendmail/Postfix,
and more using your web browser.

After installation, enter the URL https://localhost:10000/ into your browser
and login as root with your root password. Please consider logging in and
modify your password for security issue.

PLEASE NOTE THAT THIS VERSION NOW USES SECURE WEB TRANSACTIONS: YOU HAVE TO
LOGIN TO "https://localhost:10000/" AND NOT "http://localhost:10000/".

%prep

%setup -q -a 2
%setup -q -D -T -c -a 9 -n %{name}-%{version}

%patch1 -p0
%patch5 -p0
%patch7 -p1
%patch8 -p1

%patch19 -p0
%patch21 -p0
%patch23 -p1
%patch29 -p1
%patch32 -p0
%patch35 -p1
%patch37 -p1
%patch38 -p1
%patch39 -p1
%patch44 -p0
%patch45 -p1

rm -rf cfengine inetd jabber netsaint pptp-server sentry webalizer wuftpd

find bind8 -type f -maxdepth 1 | xargs perl -pi -e 's|/var/run/named\.pid|/var/run/named/named.pid|'

# daouda: added mageia-linux to known OS
cp config-mandrake-linux config-mageia

perl -pi -e 's|mandrake-linux|mageia mandrake-linux| if $_ =~ /^os_support.*mandrake-linux/ && $_ !~ /mageia/' */module.info
perl -pi -e 's|mageia|mageia{-r "/etc/named.boot"}| if $_ =~ /^os_support.*mageia/' dnsadmin/module.info

# adapt to systemd
%if "%{_libexecdir}" == "/usr/libexec"
perl -pi -e 's|/etc/rc.d/init.d/iptables|%{_libexecdir}/iptables.init|g' firewall/mandrake-linux-lib.pl
%endif
perl -pi -e 's|/etc/(rc.d/)*init.d/([^ ]*)|/sbin/service \2|g' */config-mandrake-linux* */config-\*-linux net/mandrake-linux-lib.pl

(find . -name '*.cgi' ; find . -name '*.pl') | perl perlpath.pl /usr/bin/perl -
rm -f mount/freebsd-mounts-*
rm -f mount/openbsd-mounts-*

find -name ".xvpics" -o -name ".*.swp" | xargs rm -rf

%build

# nothing to do here...

%install
# IMPORTANT: there is no %{_datadir} and so on, since the directories are decided by the post install script.
mkdir -p %{buildroot}/usr/share/webmin
mkdir -p %{buildroot}/%{_initrddir}
mkdir -p %{buildroot}/usr/bin

find -type f -print0 | xargs -0 chmod a+r
find -type d -print0 | xargs -0 chmod a+rx

cp -a * %{buildroot}/usr/share/webmin
install -m755 %{SOURCE6} %{buildroot}/%{_initrddir}/webmin
install -m755 %{SOURCE4} %{buildroot}/usr/share/webmin/postinstall.sh
install -m755 %{SOURCE5} %{buildroot}/usr/bin

mkdir -p %{buildroot}/%{_sysconfdir}/pam.d

install -m755 %{SOURCE14} %{buildroot}/%{_sysconfdir}/pam.d/webmin

rm -rf %{buildroot}/usr/share/webmin/*/{CVS,*/CVS}
rm -f `find %{buildroot} -type f -name .cvsignore`

# (gc) remove zero-length files (to check sometimes if they are still zero-length'ed)
for i in /usr/share/webmin/caldera/images/letters/254.gif /usr/share/webmin/i4lctrl-0.6.7/lang/de /usr/share/webmin/caldera/images/letters/255.gif; do
    if [ -f $i ]; then rm -f %{buildroot}$i; fi
done

echo "rpm" > %{buildroot}/usr/share/webmin/install-type

# remove macos files (breaks build in find command in find-debuginfo.sh)
rm -f %{buildroot}/usr/share/webmin/mount/macos-mounts*

echo 'blue-theme' > %{buildroot}%{_datadir}/webmin/defaulttheme


# Install icons
install -d -m 0755 %{buildroot}%{_liconsdir}
install -d -m 0755 %{buildroot}%{_miconsdir}
install -m 0644 %{SOURCE11} %{buildroot}%{_miconsdir}/webmin.png
install -m 0644 %{SOURCE12} %{buildroot}%{_iconsdir}/webmin.png
install -m 0644 %{SOURCE11} %{buildroot}%{_liconsdir}/webmin.png

# Menu entry

# XDG menu
install -d %{buildroot}%{_datadir}/applications
cat > %{buildroot}%{_datadir}/applications/mageia-%{name}.desktop << EOF
[Desktop Entry]
Name=%{name}
Comment=%{summary}
Exec=%{_bindir}/www-browser https://localhost:10000/
Icon=%{name}
Terminal=false
Type=Application
Categories=X-Mageia-System-Configuration-Other;Settings;
EOF

rm -fr %{buildroot}/usr/share/webmin/acl/Authen-SolarisRBAC-0.1

#logrotate
install -d %{buildroot}%{_sysconfdir}/logrotate.d
install -m 0644 %{SOURCE15} %{buildroot}%{_sysconfdir}/logrotate.d/webmin

# create /var/run/webmin
mkdir -p %{buildroot}%{_tmpfilesdir}
cat > %{buildroot}%{_tmpfilesdir}/%{name}.conf <<EOF
d /run/webmin 0700 root bin -
EOF

%post
if [ "$1" != 0 ]; then
    service webmin status >/dev/null 2>/dev/null && need_restart=1
    service webmin stop >/dev/null 2>/dev/null || :
else
    [[ -e /etc/cron.allow ]] && if [ "x`grep root /etc/cron.allow`" == "x" ] ; then
	echo root >> /etc/cron.allow
    fi
fi
/usr/share/webmin/postinstall.sh
%_tmpfilescreate %{name}
%_post_service %{name}
[[ -n $need_restart ]] && service webmin start >/dev/null 2>/dev/null || :

%preun
%_preun_service webmin

%postun
if [ "$1" = 0 ]; then
    rm -rf /etc/webmin /var/webmin /var/lib/webmin /var/log/webmin
fi

%files
%doc README LICENCE
%{_initrddir}/webmin
%config(noreplace) %{_sysconfdir}/pam.d/webmin
%config(noreplace) %{_sysconfdir}/logrotate.d/webmin
/usr/share/webmin
/usr/bin/%{name}
%{_iconsdir}/%{name}.png
%{_liconsdir}/%{name}.png
%{_miconsdir}/%{name}.png
%{_datadir}/applications/*.desktop
%{_tmpfilesdir}/%{name}.conf


%changelog
* Wed May 21 2014 luigiwalser <luigiwalser> 1.690-1.mga3
+ Revision: 624748
- 1.690
- 1.680
- remove several patches for issues fixed upstream
- fix openssl.cnf path in openvpn module config (mga#10713)
- disable webmin update notifications (mga#10713)

* Mon Apr 22 2013 luigiwalser <luigiwalser> 1.620-3.mga3
+ Revision: 410939
- require perl-Authen-Libwrap so it is not pulled from cpan
- fix syslog config
- fix OS version detection
- require perl-IO-Tty and suggest perl-ldap so they are not pulled from cpan

* Sun Mar 24 2013 colin <colin> 1.620-2.mga3
+ Revision: 404859
- Add systemd requires and general post/pre fixes (mga#9302)

* Thu Feb 07 2013 luigiwalser <luigiwalser> 1.620-1.mga3
+ Revision: 395123
- remove macos files (breaks build in find command in find-debuginfo.sh)
- 1.620

  + fwang <fwang>
    - update rpm group

  + umeabot <umeabot>
    - Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Tue Dec 18 2012 luigiwalser <luigiwalser> 1.610-6.mga3
+ Revision: 332609
- use _post_service so that systemd sees the service
- use systemctl with openvpn.target to stop/start openvpn service
- attempt to fix openvpn config

* Fri Dec 14 2012 luigiwalser <luigiwalser> 1.610-5.mga3
+ Revision: 330945
- fix more module configs
- fix tmpfiles config
- remove pptp-server module

* Fri Dec 14 2012 luigiwalser <luigiwalser> 1.610-4.mga3
+ Revision: 330611
- fix syslog module configuration
- add working sshd and grub module configs
- remove useless modules
- adapt to systemd (use service command instead of init.d scripts)
- more urpmi fixes from Derek Jennings

* Thu Dec 13 2012 luigiwalser <luigiwalser> 1.610-3.mga3
+ Revision: 330549
- use systemd-tmpfiles to create /var/run/webmin
- fix service names for nfs, mysqld, and pptp

* Thu Dec 13 2012 luigiwalser <luigiwalser> 1.610-2.mga3
+ Revision: 330411
- more fixes for adapting to mageia (urpmi usage, desktop file, module configs)

* Wed Dec 12 2012 luigiwalser <luigiwalser> 1.610-1.mga3
+ Revision: 329967
- 1.610 (fixes several security issues)
- rediff patches 1 and 33

* Sun May 15 2011 pterjan <pterjan> 1.550-2.mga1
+ Revision: 99040
- Rebuild for fixed find-requires

* Tue May 03 2011 ennael <ennael> 1.550-1.mga1
+ Revision: 94392
- clean spec file
- remove uneeded patches (still some work to be done)
- replace mandriva icons
- remove mandriva theme
- remove very old webmin modules
- imported package webmin

